//+------------------------------------------------------------------+
//|                                      iDeltaPriceLevl_Dinamic.mq4 |
//|                                          Copyright 2013, -Aleks- |
//|                            https://www.mql5.com/ru/users/-aleks- |
//+------------------------------------------------------------------+
#property copyright "-Aleks-"
#property link      "https://www.mql5.com/ru/users/-aleks-"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 clrAqua
#property indicator_color2 clrBurlyWood
#property indicator_color3 clrGreenYellow

//---- input parameters

extern int iDeltaTF_Open=1440;
int TFT=0;
extern int pMAT=176;
int shiftMAT=0;
int typeMAT=0;
int priceMAT=0;
extern int FixPrice=100; //      

extern int nBars=1000;    //  
int BarsN=nBars;

//---- buffers

double MA_NewTime[];
double MA_NowTime[];
double Price_NowTime[];

int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffers are used for counting.
   IndicatorBuffers(2);
   SetIndexBuffer(0,MA_NewTime);
   SetIndexBuffer(1,MA_NowTime);
   SetIndexBuffer(2,Price_NowTime);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
//----
//---- name for DataWindow and indicator subwindow label
   short_name="iDeltaFixPriceLevlMA";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"MA_NewTime");
   SetIndexLabel(1,"MA_NowTime");
   SetIndexLabel(1,"Price_NowTime");

   IndicatorSetDouble(INDICATOR_MAXIMUM,150);
   IndicatorSetDouble(INDICATOR_MINIMUM,-150);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,30);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,-30);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
//---- check for possible errors
   if(ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if(ExtCountedBars>0) ExtCountedBars--;
   int pos;
   if(nBars==0) pos=Bars-ExtCountedBars-1;
   else  pos=nBars-ExtCountedBars-1;
   while(pos>=0)
     {
      datetime  Open_timePos=iTime(_Symbol,0,pos);
      MqlDateTime str1;
      TimeToStruct(Open_timePos,str1);
      str1.hour=0;
      str1.min=0;
      str1.sec=0;

      datetime start_time=StructToTime(str1);

      //Print("posT=",pos," =",TimeToStr(start_time));
      int D_Shift=iBarShift(_Symbol,iDeltaTF_Open,start_time,false); //        

      //----
      //          
      //1.               
      int BarsGo=iBarShift(_Symbol,0,start_time,false)-pos; //,       ( )

                                                            //2.1.       
      int HighBars=iHighest(_Symbol,0,MODE_HIGH,BarsGo,pos);
      //2.2.       
      int LowBars=iLowest(_Symbol,0,MODE_LOW,BarsGo,pos);

      MA_NewTime[pos]=(MATf(BarsGo+pos)-iOpen(Symbol(),iDeltaTF_Open,D_Shift))/(FixPrice*Point)*100; //         
      MA_NowTime[pos]=(MATf(pos)-iOpen(Symbol(),iDeltaTF_Open,D_Shift))/(FixPrice*Point)*100;        //       
      Price_NowTime[pos]=(Open[pos]-iOpen(Symbol(),iDeltaTF_Open,D_Shift))/(FixPrice*Point)*100;     //       
      pos--;
     }

   return(0);
  }
//+------------------------------------------------------------------+
double MATf(int index)
  {
   double MAT=0;
   MAT=NormalizeDouble(iMA(Symbol(),TFT,pMAT,shiftMAT,typeMAT,priceMAT,index),Digits);
   return MAT;
  }

//+------------------------------------------------------------------+
